Delay::Delay (const unsigned long long DURATION, const bool NO_START_DELAY)
{
	_duration = DURATION;
	_noStartDelay = NO_START_DELAY;
	
	Core::startGlobalInterrupt();
	Core::startInterruptTimer0();
}

void Delay::state()
{
	if (started == false)
	{
		if (_noStartDelay == false)
		{
			_timePrevious = Core::ms() + _duration;
		}
		else
		{
			_timePrevious = Core::ms();
		}
		
		started = true;
	}
	
	if (Core::ms() >= _timePrevious)
	{
		_timePrevious = Core::ms() + _duration;
		update = true;
	}
	else
	{
		update = false;
	}
}

void Delay::set (const unsigned long long DURATION)
{
	_duration = DURATION;
	started = false;
}

void Delay::reset()
{
	started = false;
	update = false;
}
